var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { Link, graphql, useStaticQuery } from 'gatsby';
import Img from 'gatsby-image';
import styled from 'styled-components';
import { Icon } from '@deer-ui/core/icon';
import { Label } from '@deer-ui/core/label';
import { DocSearch } from './doc-search';
import { useColorMode } from './theme';
import { MainContentWrapper } from './common-style';
var QUERY = graphql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  query Header {\n    logo: file(relativePath: { eq: \"logo.png\" }) {\n      childImageSharp {\n        fixed(width: 34, height: 34) {\n          ...GatsbyImageSharpFixed_noBase64\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        title\n        github\n        algoliaDocSearch {\n          enabled\n          apiKey\n          indexName\n        }\n        nav {\n          title\n          url\n        }\n      }\n    }\n  }\n"], ["\n  query Header {\n    logo: file(relativePath: { eq: \"logo.png\" }) {\n      childImageSharp {\n        fixed(width: 34, height: 34) {\n          ...GatsbyImageSharpFixed_noBase64\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        title\n        github\n        algoliaDocSearch {\n          enabled\n          apiKey\n          indexName\n        }\n        nav {\n          title\n          url\n        }\n      }\n    }\n  }\n"])));
var Container = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  background-color: ", ";\n  border-bottom: 1px solid #f7f7f7;\n  padding: 16 0;\n"], ["\n  background-color: ", ";\n  border-bottom: 1px solid #f7f7f7;\n  padding: 16 0;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.color.body;
});
var Header = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: flex;\n  flex-flow: row nowrap;\n  position: relative;\n  padding: 0 20px;\n"], ["\n  display: flex;\n  flex-flow: row nowrap;\n  position: relative;\n  padding: 0 20px;\n"])));
var LogoText = styled.span(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  margin-left: 10px;\n  color: #444;\n  font-size: 18px;\n"], ["\n  margin-left: 10px;\n  color: #444;\n  font-size: 18px;\n"])));
var LogoLink = styled(Link)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  margin-right: 10px;\n"], ["\n  margin-right: 10px;\n"])));
var Box = styled.span(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\n"], ["\n\n"])));
var Nav = styled.nav(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  /* height: 34; */\n  margin-left: 10;\n  position: relative;\n  display: flex;\n"], ["\n  /* height: 34; */\n  margin-left: 10;\n  position: relative;\n  display: flex;\n"])));
var NavList = styled.ul(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  list-style: none;\n  margin: 0;\n  padding: 0;\n  align-self: flex-end;\n  display: flex;\n  overflow-x: auto;\n  list-style: none;\n  margin: 0rem;\n"], ["\n  list-style: none;\n  margin: 0;\n  padding: 0;\n  align-self: flex-end;\n  display: flex;\n  overflow-x: auto;\n  list-style: none;\n  margin: 0rem;\n"])));
var SideHelpers = styled(NavList)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n"], ["\n"])));
var HelperItem = styled.li(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  font-size: 18px;\n  color: #666;\n\n  a {\n    color: inherit;\n  }\n"], ["\n  font-size: 18px;\n  color: #666;\n\n  a {\n    color: inherit;\n  }\n"])));
var NavListItem = styled.li(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n  color: #000;\n  display: inline-block;\n  line-height: 2.8rem;\n  color: #666;\n"], ["\n  color: #000;\n  display: inline-block;\n  line-height: 2.8rem;\n  color: #666;\n"])));
var modeIcons = {
    light: 'sun',
    dark: 'moon',
};
function getInverseMode(mode) {
    return mode === 'light' ? 'dark' : 'light';
}
function ColorModeSwitcher() {
    var _a = useColorMode(), mode = _a[0], setMode = _a[1];
    return (React.createElement(Label, { onClick: function () { setMode(getInverseMode); } },
        React.createElement(Icon, { n: modeIcons[mode] })));
}
export function ProjectHeader() {
    var data = useStaticQuery(QUERY);
    return (React.createElement(Container, null,
        React.createElement(MainContentWrapper, null,
            React.createElement(Header, { className: "layout a-i-c flex" },
                React.createElement(LogoLink, { to: "/", className: "layout a-i-c" },
                    React.createElement(Img, { fixed: data.logo.childImageSharp.fixed, alt: data.site.siteMetadata.title }),
                    React.createElement(LogoText, null, data.site.siteMetadata.title)),
                React.createElement(Nav, null,
                    React.createElement(NavList, { className: "layout a-i-c" }, data.site.siteMetadata.nav.map(function (_a) {
                        var title = _a.title, url = _a.url;
                        return (React.createElement(NavListItem, { key: title },
                            React.createElement(Link, { to: url }, title)));
                    }))),
                React.createElement("span", { className: "flex" }),
                React.createElement(Box, null, data.site.siteMetadata.algoliaDocSearch.enabled && (React.createElement(DocSearch, __assign({}, data.site.siteMetadata.algoliaDocSearch)))),
                React.createElement(Nav, null,
                    React.createElement(SideHelpers, { className: "layout a-i-c" },
                        React.createElement(HelperItem, null,
                            React.createElement(Label, null,
                                React.createElement("a", { href: data.site.siteMetadata.github, target: "_blank", rel: "noopener noreferrer" },
                                    React.createElement(Icon, { n: "github", s: "b" }))))))))));
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11;
