var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import styled from 'styled-components';
import { ToolTip } from '@deer-ui/core';
var Table = styled.table(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: table !important;\n  background-color: transparent;\n  border-collapse: collapse;\n  color: text;\n  overflow-y: hidden;\n  overflow-x: initial;\n  width: 100%;\n  font-size: 14;\n  padding: 0;\n  border-spacing: 0;\n  border-style: hidden;\n  table-layout: auto;\n  border-radius: 4;\n"], ["\n  display: table !important;\n  background-color: transparent;\n  border-collapse: collapse;\n  color: text;\n  overflow-y: hidden;\n  overflow-x: initial;\n  width: 100%;\n  font-size: 14;\n  padding: 0;\n  border-spacing: 0;\n  border-style: hidden;\n  table-layout: auto;\n  border-radius: 4;\n"])));
var Thead = styled.thead(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  color: text;\n  background-color: secondary-bg;\n  text-align: left;\n"], ["\n  color: text;\n  background-color: secondary-bg;\n  text-align: left;\n"])));
var Th = styled.th(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  font-weight: 400;\n  padding: 20;\n  &:first-child {\n    border-radius: 4 0 0;\n  }\n  &:last-child {\n    border-radius: 0 4 0;\n  }\n"], ["\n  font-weight: 400;\n  padding: 20;\n  &:first-child {\n    border-radius: 4 0 0;\n  }\n  &:last-child {\n    border-radius: 0 4 0;\n  }\n"])));
var Tbody = styled.tbody(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  > tr {\n    border-top: 1;\n    border-color: border;\n  }\n"], ["\n  > tr {\n    border-top: 1;\n    border-color: border;\n  }\n"])));
var Td = styled.td(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  line-height: 2;\n  font-weight: 200;\n  padding: 12 20;\n"], ["\n  line-height: 2;\n  font-weight: 200;\n  padding: 12 20;\n"])));
var GROUP_REGEXP = /^\[(.*)]\s+/;
function sanitizeDescription(description) {
    return description && description.replace(GROUP_REGEXP, '');
}
function getGroup(meta) {
    if (!meta.description)
        return null;
    var matches = meta.description.match(GROUP_REGEXP);
    if (!matches)
        return null;
    return matches[1];
}
export function Props(_a) {
    var of = _a.of;
    console.dir(of);
    return React.createElement("span", null);
    var properties = React.useMemo(function () { return Object.entries(of.propTypes).reduce(function (properties, _a) {
        var name = _a[0], prop = _a[1];
        var group = getGroup(prop.__meta) || 'default';
        properties[group] = properties[group] || [];
        properties[group].push([name, prop]);
        return properties;
    }, {}); }, []);
    var _b = React.useState(function () { return Object.keys(properties).reduce(function (state, group) {
        var _a;
        if (group === 'default')
            return state;
        properties[group] = properties[group] || [];
        properties[group].push();
        return __assign(__assign({}, state), (_a = {}, _a[group] = false, _a));
    }, []); }), groupsState = _b[0], setGroupsState = _b[1];
    return (React.createElement(Table, null,
        React.createElement(Thead, null,
            React.createElement("tr", null,
                React.createElement(Th, null, "Property"),
                React.createElement(Th, null, "Type"),
                React.createElement(Th, null, "Required"),
                React.createElement(Th, null, "Default"),
                React.createElement(Th, null, "Description"))),
        React.createElement(Tbody, null, Object.entries(properties).map(function (_a) {
            var group = _a[0], propTypes = _a[1];
            return (React.createElement(React.Fragment, { key: group },
                group !== 'default' && (React.createElement("tr", null,
                    React.createElement(Td, { colSpan: 5, style: { textAlign: 'center' } },
                        React.createElement("a", { href: "#", onClick: function (event) {
                                event.preventDefault();
                                setGroupsState(function (state) {
                                    var _a;
                                    return (__assign(__assign({}, state), (_a = {}, _a[group] = !state[group], _a)));
                                });
                            } },
                            groupsState[group] ? 'Hide' : 'Show',
                            " ",
                            group,
                            " properties")))),
                propTypes.map(function (_a) {
                    var name = _a[0], prop = _a[1];
                    var meta = prop.__meta;
                    var propType = meta.toString();
                    var tooltip = propType !== meta.type.name;
                    var group = getGroup(meta);
                    if (group && group !== 'default' && !groupsState[group]) {
                        return null;
                    }
                    return (React.createElement("tr", { key: name },
                        React.createElement(Td, null, name),
                        React.createElement(Td, null, tooltip ? (React.createElement("a", { href: "#" },
                            tooltip && (React.createElement(ToolTip, { title: propType })),
                            meta.type.name)) : (propType)),
                        React.createElement(Td, null, meta.required ? 'true' : 'false'),
                        React.createElement(Td, null, meta.defaultValue ? meta.defaultValue.value : '-'),
                        React.createElement(Td, { dangerouslySetInnerHTML: {
                                __html: sanitizeDescription(meta.description),
                            } })));
                })));
        }))));
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
