var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import Helmet from 'react-helmet';
import { graphql, useStaticQuery } from 'gatsby';
var detailsQuery = graphql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  query DefaultSEOQuery {\n    socialImage: file(relativePath: { eq: \"logo.png\" }) {\n      childImageSharp {\n        fixed(width: 665, height: 200) {\n          ...GatsbyImageSharpFixed_noBase64\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        title\n        description\n        siteUrl\n        author\n      }\n    }\n  }\n"], ["\n  query DefaultSEOQuery {\n    socialImage: file(relativePath: { eq: \"logo.png\" }) {\n      childImageSharp {\n        fixed(width: 665, height: 200) {\n          ...GatsbyImageSharpFixed_noBase64\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        title\n        description\n        siteUrl\n        author\n      }\n    }\n  }\n"])));
export default function SEO(_a) {
    var title = _a.title;
    var data = useStaticQuery(detailsQuery);
    var metaDescription = data.site.siteMetadata.description;
    var metaTitle = title || data.site.siteMetadata.title;
    var url = data.site.siteMetadata.siteUrl;
    var image = url + data.socialImage.childImageSharp.fixed.src;
    return (React.createElement(Helmet, { htmlAttributes: { lang: 'en' }, title: metaTitle, meta: [
            {
                name: 'description',
                content: metaDescription,
            },
            {
                property: 'og:title',
                content: metaTitle,
            },
            {
                property: 'og:url',
                content: url,
            },
            {
                property: 'og:description',
                content: metaDescription,
            },
            {
                property: 'og:type',
                content: 'website',
            },
            {
                property: 'og:image',
                content: image,
            },
        ] }));
}
var templateObject_1;
