var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React, { useEffect, useState } from 'react';
import { StaticQuery, graphql, Link } from 'gatsby';
import styled from 'styled-components';
import { Icon } from '@deer-ui/core';
var QUERY = graphql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  query Sidebar {\n    allSitePage {\n      edges {\n        node {\n          id\n          path\n          context {\n            frontmatter {\n              title\n              menu\n              order\n            }\n          }\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        menu\n        defaultShowAllMenu\n      }\n    }\n  }\n"], ["\n  query Sidebar {\n    allSitePage {\n      edges {\n        node {\n          id\n          path\n          context {\n            frontmatter {\n              title\n              menu\n              order\n            }\n          }\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        menu\n        defaultShowAllMenu\n      }\n    }\n  }\n"])));
var createOrFindGroup = function (name, groups) {
    var group = groups.find(function (group) { return group.name === name; });
    if (!group) {
        group = { name: name, pages: [] };
        groups.push(group);
    }
    return group;
};
var sortByOrder = function (a, b) {
    var diff = (a.context.frontmatter.order || 0) - (b.context.frontmatter.order || 0);
    return diff === 0 ? 0 : diff > 0 ? 1 : -1;
};
var pagesToNavGroups = function (pages) { return pages.reduce(function (groups, page) {
    if (!page.context.frontmatter.menu) {
        return groups;
    }
    var group = createOrFindGroup(page.context.frontmatter.menu, groups);
    group.pages.push(page);
    group.pages.sort(sortByOrder);
    return groups;
}, []); };
var ListGroup = styled.ul(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  margin: 0;\n  padding: 0;\n\n  ul {\n    /* padding: 0 0 0 10px; */\n  }\n"], ["\n  margin: 0;\n  padding: 0;\n\n  ul {\n    /* padding: 0 0 0 10px; */\n  }\n"])));
var docMenuWidth = "200px";
var Nav = styled.nav(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  /* padding: 0 20px; */\n  background-color: #fafafa;\n  position: fixed;\n  left: 0;\n  top: 50px;\n  bottom: 0;\n  width: ", ";\n  overflow-y: auto;\n"], ["\n  /* padding: 0 20px; */\n  background-color: #fafafa;\n  position: fixed;\n  left: 0;\n  top: 50px;\n  bottom: 0;\n  width: ", ";\n  overflow-y: auto;\n"])), docMenuWidth);
var NavGroup = styled(ListGroup)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  /* margin-bottom: 20px; */\n"], ["\n  /* margin-bottom: 20px; */\n"])));
var NavItemBasic = styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  padding: 12px 20px;\n"], ["\n  padding: 12px 20px;\n"])));
var NavGroupTitle = styled(NavItemBasic)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  cursor: pointer;\n\n  .title {\n    font-size: 16px;\n    font-weight: 500;\n  }\n"], ["\n  cursor: pointer;\n\n  .title {\n    font-size: 16px;\n    font-weight: 500;\n  }\n"])));
var NavGroupMenu = styled(ListGroup)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  height: auto;\n  transition: padding 0.2s ease;\n  padding: 5px 0;\n  &._hide {\n    height: 0;\n    opacity: 0;\n    padding: 0;\n    visibility: hidden;\n  }\n"], ["\n  height: auto;\n  transition: padding 0.2s ease;\n  padding: 5px 0;\n  &._hide {\n    height: 0;\n    opacity: 0;\n    padding: 0;\n    visibility: hidden;\n  }\n"])));
var NavGroupMenuItem = styled.li(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  list-style-type: none;\n\n  a {\n    padding: 8px 10px 8px 30px;\n    color: ", ";\n    display: block;\n    transition: base;\n    transition-property: color;\n    border-left: 3px;\n    border-color: transparent;\n\n    &:hover {\n      color: ", ";\n      background-color: ", ";\n    }\n\n    &.active {\n      font-weight: 600;\n      border-left: 3px solid ", ";\n      background-color: ", ";\n    }\n  }\n"], ["\n  list-style-type: none;\n\n  a {\n    padding: 8px 10px 8px 30px;\n    color: ", ";\n    display: block;\n    transition: base;\n    transition-property: color;\n    border-left: 3px;\n    border-color: transparent;\n\n    &:hover {\n      color: ", ";\n      background-color: ", ";\n    }\n\n    &.active {\n      font-weight: 600;\n      border-left: 3px solid ", ";\n      background-color: ", ";\n    }\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.color['nav-link'];
}, function (_a) {
    var theme = _a.theme;
    return theme.color['nav-link-hover'];
}, function (_a) {
    var theme = _a.theme;
    return theme.color['nav-link-hover-bg'];
}, function (_a) {
    var theme = _a.theme;
    return theme.color.primary;
}, function (_a) {
    var theme = _a.theme;
    return theme.color['nav-link-hover-bg'];
});
var sortGroupsWithConfig = function (sideMenuFromConfig) { return function (a, b) {
    var indexA = sideMenuFromConfig.indexOf(a.name);
    var indexB = sideMenuFromConfig.indexOf(b.name);
    var diff = indexA - indexB;
    // eslint-disable-next-line no-nested-ternary
    return diff === 0 ? 0 : (diff < 0 ? -1 : 1);
}; };
var NavGroupWrapper = function (_a) {
    var navGroup = _a.navGroup, _b = _a.defaultShowAllMenu, defaultShowAllMenu = _b === void 0 ? true : _b;
    var _c = useState(defaultShowAllMenu), isShow = _c[0], setIsShow = _c[1];
    return (React.createElement(NavGroup, { key: navGroup.name },
        React.createElement(NavGroupTitle, { className: "layout a-i-c j-c-b", onClick: function (e) {
                setIsShow(!isShow);
            } },
            React.createElement("span", { className: "title" }, navGroup.name),
            React.createElement(Icon, { n: isShow ? 'chevron-down' : 'chevron-right' })),
        React.createElement(NavGroupMenu, { className: isShow ? 'show' : '_hide' }, navGroup.pages.map(function (page) { return (React.createElement(NavGroupMenuItem, { key: page.id },
            React.createElement(Link, { activeClassName: "active", to: page.path, ref: function (e) {
                    if (!isShow && e) {
                        var isActive = e.classList.contains('active');
                        if (isActive) {
                            setIsShow(true);
                        }
                    }
                } }, page.context.frontmatter.title))); }))));
};
export function SideNav() {
    useEffect(function () {
        var sideNav = document.querySelector('#sideNav');
        if (!sideNav)
            return;
        var activeSideNavItem = sideNav.querySelector('.active');
        if (activeSideNavItem) {
            sideNav.scrollTop = activeSideNavItem.offsetTop;
        }
    }, []);
    return (React.createElement(StaticQuery, { query: QUERY, render: function (data) {
            var navGroups = pagesToNavGroups(data.allSitePage.edges
                .map(function (edge) { return edge.node; })
                .filter(function (node) { return node.context && node.context.frontmatter; }));
            navGroups.sort(sortGroupsWithConfig(data.site.siteMetadata.menu));
            return (React.createElement(Nav, { id: "sideNav" }, navGroups.map(function (navGroup) { return (React.createElement(NavGroupWrapper, { key: navGroup.name, defaultShowAllMenu: data.site.siteMetadata.defaultShowAllMenu, navGroup: navGroup })); })));
        } }));
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
