var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState, useCallback, useMemo } from 'react';
import { graphql } from 'gatsby';
import styled, { css } from 'styled-components';
import DefaultLayout from './default';
import { SideNav } from '../components/side-nav';
import { Article } from '../components/archive';
import { MainContentWrapper, device } from '../components/common-style';
var MenuContext = React.createContext();
var MenuProvider = function (_a) {
    var children = _a.children;
    var _b = useState(false), opened = _b[0], setOpened = _b[1];
    var toggle = useCallback(function () { return setOpened(function (_opened) { return !_opened; }); }, []);
    var value = useMemo(function () { return ({ opened: opened, toggle: toggle }); }, [opened, toggle]);
    return React.createElement(MenuContext.Provider, { value: value }, children);
};
var SideNavWrapper = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  \n  ", "\n"], ["\n  \n  ",
    "\n"])), function (c) { return c.opened && css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    color: red;\n  "], ["\n    color: red;\n  "]))); });
var ArticleContent = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  width: 70%;\n  max-width: 1200px;\n  margin: 0 auto;\n  \n  @media ", " {\n    width: 90%;\n  }\n"], ["\n  width: 70%;\n  max-width: 1200px;\n  margin: 0 auto;\n  \n  @media ", " {\n    width: 90%;\n  }\n"])), device.mobileM);
var DocLayout = /** @class */ (function (_super) {
    __extends(DocLayout, _super);
    function DocLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DocLayout.prototype.render = function () {
        var _a = this.props, children = _a.children, props = __rest(_a, ["children"]);
        return (React.createElement(MenuProvider, null,
            React.createElement(DefaultLayout, __assign({}, props),
                React.createElement(MainContentWrapper, null,
                    React.createElement(MenuContext.Consumer, null, function (_a) {
                        var opened = _a.opened, toggle = _a.toggle;
                        return (React.createElement(SideNavWrapper, { opened: opened },
                            React.createElement(SideNav, null)));
                    }),
                    React.createElement(Article, null,
                        React.createElement(ArticleContent, null, children))))));
    };
    return DocLayout;
}(React.Component));
export default DocLayout;
export var pageQuery = graphql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  query BlogPostQueryDoc($id: String) {\n    mdx(id: { eq: $id }) {\n      id\n      body\n      frontmatter {\n        title\n      }\n    }\n  }\n"], ["\n  query BlogPostQueryDoc($id: String) {\n    mdx(id: { eq: $id }) {\n      id\n      body\n      frontmatter {\n        title\n      }\n    }\n  }\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
